unit Export;

interface

uses
     SysVars,SysConsts,SysRecords,MyFuncs,
     //
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, CheckLst, ExtCtrls,MsgDlg,Types, ComCtrls;

type
  TForm_Export = class(TForm)
    Image: TImage;
    Label1: TLabel;
    Bevel1: TBevel;
    Panel1: TPanel;
    Panel2: TPanel;
    Button_OK: TButton;
    Button_Cancel: TButton;
    CheckListBox: TCheckListBox;
    SaveDialog: TSaveDialog;
    procedure Button_CancelClick(Sender: TObject);
    procedure Button_OKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
          function  GetGroupName(sGroupIDs: String):String;
    { Public declarations }
  end;

var
     Form_Export: TForm_Export;

implementation

uses Main;

{$R *.dfm}

procedure TForm_Export.Button_CancelClick(Sender: TObject);
begin
     Tag  := 0;
     Close;
end;

procedure TForm_Export.Button_OKClick(Sender: TObject);
var
     I    : Integer;
     TmpS : string;
     TxtF : TextFile;
begin
     //
     try
          if SaveDialog.Execute then begin
               AssignFile(TxtF,SaveDialog.FileName);
               Rewrite(TxtF);

               //дб
               TmpS := ',';
               for I:= 0 to High(grFields_Member) do begin
                    if CheckListBox.Checked[I] then begin
                         TmpS := TmpS+ grFields_Member[I].Caption+',';
                    end;
               end;
               Delete(TmpS,Length(TmpS),1);
               WriteLn(TxtF,TmpS);

               //д
               MainForm.RemoteADOQuery.First;
               while not MainForm.RemoteADOQuery.eof do begin
                    TmpS := GetGroupName(MainForm.RemoteADOQuery.FieldByName('GroupIDs').AsString)+',';
                    for I:= 0 to High(grFields_Member) do begin
                         if CheckListBox.Checked[I] then begin
                              TmpS := TmpS+ MainForm.RemoteADOQuery.FieldByName('Item'+IntToStr(I)).AsString+',';
                         end;
                    end;
                    Delete(TmpS,Length(TmpS),1);
                    WriteLn(TxtF,TmpS);
                    MainForm.RemoteADOQuery.Next;
               end;
               //رļ
               System.CloseFile(TxtF);
               MessageDialog(#13+'*****   ɹ   *****'+Chr(13)+SaveDialog.FileName,
                    mtInformation, [mbOk], 0);
               //
               Close;
          end
     except
          MessageDialog(#13+'δɹļѾ',
               mtError, [mbOk], 0);
     end;

end;

procedure TForm_Export.FormShow(Sender: TObject);
var
     I,J  : Integer;
begin
     CheckListBox.Items.Clear;
     for I:=0 to High(grFields_Member) do begin
          CheckListBox.Items.Add(grFields_Member[I].Caption);
          //Ĭѡʾֶ
          for J:=0 to High(grGrid_Member) do begin
               if grGrid_Member[J]=I then begin
                    CheckListBox.Checked[I]  := True;
                    break;
               end;
          end;
     end;
end;

function TForm_Export.GetGroupName(sGroupIDs: String): String;
var
     I,J,iID   : Integer;
     ssGroup   : TStringDynArray;
     oNode     : TTreeNode;
     sLink     : String;
     bCheck    : Boolean;
     sID       : String;
     iPos      : Integer;
begin
     //ɾĬϵ-1
     sID  := ',-1,';
     iPos := Pos(sID,sGroupIDs);
     if iPos>0 then begin
          Delete(sGroupIDs,iPos+1,Length(sID)-1);
     end;
     //ɾǰ,ڷָ
     while sGroupIDs[1]=',' do begin
          Delete(sGroupIDs,1,1);
          if sGroupIDs='' then begin
               break;
          end;
     end;
     //ָб
     ssGroup   := SplitStr(sGroupIDs,',');

     //ϵб
     Result    := '';
     for I:=0 to High(ssGroup) do begin
          iID  := StrToIntDef(ssGroup[I],-1);
          //
          if iID>0 then begin
               for J:=1 to MainForm.TreeView.Items.Count-1 do begin
                    if MainForm.TreeView.Items[J].StateIndex=iID then begin
                         oNode     := MainForm.TreeView.Items[J];
                         sLink     := oNode.Text;
                         while oNode.Level>1 do begin
                              oNode     := oNode.Parent;
                              sLink     := oNode.Text+'->'+sLink;
                         end;
                         Result    := Result +'['+sLink+'] ';
                         //
                         break;
                    end;
               end;
          end;
     end;
end;

end.
