unit MemberDelete;

interface

uses
     //
     Msgdlg,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, CheckLst, ExtCtrls, DB, ADODB,Types,MyFuncs,ComCtrls,
  RemoteAdoUnit;

type
  TForm_Delete = class(TForm)
    Panel2: TPanel;
    Panel3: TPanel;
    Button_OK: TButton;
    Button_Cancel: TButton;
    Panel4: TPanel;
    CheckBox: TCheckBox;
    Label_Confirm: TLabel;
    CheckListBox: TCheckListBox;
    RemoteAdoQuery: TRemoteAdoQuery;
    procedure FormShow(Sender: TObject);
    procedure Button_CancelClick(Sender: TObject);
    procedure Button_OKClick(Sender: TObject);
  private
     isID : TIntegerDynArray;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form_Delete: TForm_Delete;

implementation

{$R *.dfm}

uses
     Main;
     
procedure TForm_Delete.FormShow(Sender: TObject);
var
     I,J,iID   : Integer;
     sGroupIDs : String;
     ssGroup   : TStringDynArray;
     oNode     : TTreeNode;
     sLink     : String;
     bCheck    : Boolean;
     sID       : String;
     iPos      : Integer;
begin

     //ϵ
     sGroupIDs := MainForm.RemoteADOQuery.FieldByName('GroupIDs').AsString; //
     //ɾĬϵ-1
     sID  := ',-1,';
     iPos := Pos(sID,sGroupIDs);
     if iPos>0 then begin
          Delete(sGroupIDs,iPos+1,Length(sID)-1);
     end;
     //ɾǰ,ڷָ
     if sGroupIDs<>'' then begin
          while sGroupIDs[1]=',' do begin
               Delete(sGroupIDs,1,1);
               if sGroupIDs='' then begin
                    break;
               end;
          end;
     end;
     //ָб
     ssGroup   := SplitStr(sGroupIDs,',');
     //
     CheckBox.Enabled    := Length(ssGroup)>1;
     CheckBox.Checked    := False;
     CheckListBox.Enabled     := CheckBox.Enabled;

     //ʾȷϢ
     Label_Confirm.Caption    := 'ȷҪɾϵ "'+MainForm.RemoteADOQuery.FieldByName('Item0').AsString+'" ';

     //ϵб
     CheckListBox.Items.Clear;
     SetLength(isID,0);
     for I:=0 to High(ssGroup) do begin
          iID  := StrToIntDef(ssGroup[I],-1);
          //
          if iID>0 then begin
               for J:=1 to MainForm.TreeView.Items.Count-1 do begin
                    if MainForm.TreeView.Items[J].StateIndex=iID then begin
                         oNode     := MainForm.TreeView.Items[J];
                         sLink     := oNode.Text;
                         while oNode.Level>1 do begin
                              oNode     := oNode.Parent;
                              sLink     := oNode.Text+' -> '+sLink;
                         end;
                         CheckListBox.Items.Add(sLink);
                         //浱ǰID
                         SetLength(isID,Length(isID)+1);
                         isID[High(isID)]    := iID;
                         //
                         break;
                    end;
               end;
          end;
     end;

end;

procedure TForm_Delete.Button_CancelClick(Sender: TObject);
begin
     Close;
end;

procedure TForm_Delete.Button_OKClick(Sender: TObject);
var
     bAll      : Boolean;
     bNone     : Boolean;
     I,iPos    : Integer;
     sGroupIDs : String;
     sID       : String;
     ssGroup   : TStringDynArray;
begin
     //Ƿȫѡ
     bAll      := True;
     bNone     := True;
     for I:=0 to CheckListBox.Count-1 do begin
          if CheckListBox.Checked[I] then begin
               bNone     := False;
          end else begin
               bAll := False;
          end;
     end;

     //ȫδѡʾ˳
     if CheckBox.Checked then begin
          if bNone and (CheckListBox.Count>0) then begin
               MessageDialog(#13+'ѡһϵ!'+#13, mtInformation,[mbOk], 0);
               Exit;
          end;
     end;

     //ȫѡУֱɾǰԱ,ɾǰԱGroupIDsеӦϵ
     if bAll or (CheckListBox.Count<=0)or(not CheckBox.Checked) then begin
          MainForm.RemoteADOQuery.Delete;
     end else begin
          sGroupIDs := MainForm.RemoteADOQuery.FieldByName('GroupIDs').AsString;
          for I:=0 to CheckListBox.Items.Count-1 do begin
               if CheckListBox.Checked[I] then begin
                    sID  := ','+IntToStr(isID[I])+',';
                    iPos := Pos(sID,sGroupIDs);
                    if iPos>0 then begin
                         Delete(sGroupIDs,iPos+1,Length(sID)-1);
                    end;
               end;
          end;
          MainForm.RemoteADOQuery.Edit;
          MainForm.RemoteADOQuery.FieldByName('GroupIDs').AsString := sGroupIDs;
          MainForm.RemoteADOQuery.Post;
     end;
     //
     MainForm.RemoteADOQuery.Close;
     MainForm.RemoteADOQuery.Open;

     //
     Close;

end;

end.
