unit QcCx;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Db, DBTables, Grids, DBGrids, XPMenu, ADODB, ExtCtrls;

type
  TForm_Search = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Edit_1: TEdit;
    Button_OK: TButton;
    Button_Cancel: TButton;
    Label3: TLabel;
    DataSource: TDataSource;
    XPMenu1: TXPMenu;
    ADOQuery: TADOQuery;
    Edit_2: TEdit;
    ComboBox_Field1: TComboBox;
    ComboBox_Field2: TComboBox;
    ComboBox_Comp1: TComboBox;
    ComboBox_Comp2: TComboBox;
    Label1: TLabel;
    RadioGroup: TRadioGroup;
    procedure Button_CancelClick(Sender: TObject);
    procedure Button_OKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form_Search: TForm_Search;

implementation

uses Main;

{$R *.DFM}

procedure TForm_Search.Button_CancelClick(Sender: TObject);
begin
     Close;
end;

procedure TForm_Search.Button_OKClick(Sender: TObject);
var
     TmpS      : String;
     Field1    : String;           //ֶ1
     Field2    : String;
     Comp1     : string;           //ȽϷ1
     Comp2     : string;
     Value1    : string;           //ֵ1
     Value2    : string;           //ֵ2
     Logical   : string;           //߼ϵ
     FieldStr  : string;
begin
     //ֶ
     Field1    := ComboBox_Field1.Text;
     Field2    := ComboBox_Field2.Text;
     //ȽϷ
     Comp1     := ComboBox_Comp1.Text;
     Comp2     := ComboBox_Comp2.Text;

     //ԱȽϷУ飨ΪΪLike
     if ((Pos('',Field1)>0)or(Pos('ʱ',Field1)>0)) and (Comp1='Like') then begin
          Comp1     := ' = ';
     end;
     if ((Pos('',Field2)>0)or(Pos('ʱ',Field2)>0)) and (Comp2='Like') then begin
          Comp2     := ' = ';
     end;

     //ֵ
     Value1    := Edit_1.Text;
     if Comp1 = 'Like' then begin
          Value1    := Value1+'%';
     end;
     Value2    := Edit_2.Text;
     if Comp2 = 'Like' then begin
          Value2    := Value2+'%';
     end;
     //߼ϵ

     if RadioGroup.ItemIndex=0 then begin
          Logical   := ' AND ';
     end else begin
          Logical   := ' OR ';
     end;

     //ѡֶ
     if (Field1<>'')and(Field2<>'') then begin
          FieldStr  := 'Select ,';
          if Field1<>Field2 then begin
               FieldStr  := 'Select ,'+Field1+','+Field2+',ID From RyQK ';
          end else begin
               FieldStr  := 'Select ,'+Field1+',ID From RyQK ';
          end;
     end else begin
          if (Field1='')and(Field2='') then begin
               FieldStr  := 'Select ,ID From RyQK ';
          end else if (Field1='') then begin
               FieldStr  := 'Select ,'+Field2+',ID From RyQK ';
          end else begin
               FieldStr  := 'Select ,'+Field1+',ID From RyQK ';
          end;
     end;
     if Edit_1.Text<>'' then begin
          if (Pos('',Field1)>0)or(Pos('ʱ',Field1)>0) then begin
               TmpS := 'Where '+Field1+' '+ Comp1+' '+'#'+Value1+'#' ;
          end else begin
               TmpS := 'Where '+Field1+' '+ Comp1+' '+''''+Value1+'''' ;
          end;
          if Edit_2.Text<>'' then begin
               TmpS := TmpS+Logical;
               if (Pos('',Field2)>0)or(Pos('ʱ',Field2)>0) then begin
                    TmpS := TmpS+' '+Field2+' '+ Comp2+' '+'#'+Value2+'#' ;
               end else begin
                    TmpS := TmpS+' '+Field2+' '+ Comp2+' '+''''+Value2+'''' ;
               end;
          end;
          //ݵһֶ
          TmpS := TmpS + ' Order By '+ Field1;
     end else if Edit_2.Text<>'' then begin
          if (Pos('',Field2)>0)or(Pos('ʱ',Field2)>0) then begin
               TmpS := ' Where '+Field2+' '+ Comp2+' '+'#'+Value2+'#' ;
          end else begin
               TmpS := ' Where '+Field2+' '+ Comp2+' '+''''+Value2+'''' ;
          end;
          //ݵڶֶ
          TmpS := TmpS + ' Order By '+ Field2;
     end else begin
          Exit;
     end;

     //յSQL
     TmpS := FieldStr+TmpS;

     ADOQuery.Close;
     ADOQuery.SQL.Clear;
     ADOQuery.SQL.Add(TmpS);
     ADOQuery.Open;

     with MainForm do begin
          DBGrid.Visible      := True;
     end;
     Close;
end;

procedure TForm_Search.FormShow(Sender: TObject);
var
     I    : Integer;
begin
     if ComboBox_Field1.ItemIndex>=0 then Exit;
     //Զֶ
     ComboBox_Field1.Items.Clear;
     ComboBox_Field2.Items.Clear;
     for I:=0 to MainForm.ADOQuery.FieldCount-1-7 do begin
          ComboBox_Field1.Items.Add(MainForm.ADOQuery.Fields[I].FullName);
          ComboBox_Field2.Items.Add(MainForm.ADOQuery.Fields[I].FullName);
     end;
     //ָĬֶ
     ComboBox_Field1.ItemIndex     := 0;
     ComboBox_Field2.ItemIndex     := 3;
     //ָĬϱȽϷΪLIKE
     ComboBox_Comp1.ItemIndex := 0;
     ComboBox_Comp2.ItemIndex := 0;
end;

end.
