unit TelIn;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, RzEdit, DB, ADODB, DBCtrls;

type
  TForm_TelIn = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Button_Take: TButton;
    Button_Off: TButton;
    Button1: TButton;
    ADOQuery: TADOQuery;
    DataSource: TDataSource;
    Timer_AutoClose: TTimer;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel_Client: TPanel;
    DBImage_Photo: TDBImage;
    RichEdit_Brief: TRzRichEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button_TakeClick(Sender: TObject);
    procedure Button_OffClick(Sender: TObject);
    procedure Timer_AutoCloseTimer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form_TelIn: TForm_TelIn;

implementation

{$R *.dfm}
uses DataHouse, Main;
procedure TForm_TelIn.Button1Click(Sender: TObject);
begin
     Close;
end;

procedure TForm_TelIn.Button_TakeClick(Sender: TObject);
var
     S    : String;
begin
     //
     S    := 'ATH1'+#13;
     MainForm.Comm.WriteCommData(Pchar(S),Length(S)+1);
     Timer_AutoClose.Enabled  := False;
end;

procedure TForm_TelIn.Button_OffClick(Sender: TObject);
var
     S    : String;
begin
     //
     S    := 'ATH1'+#13;
     MainForm.Comm.WriteCommData(Pchar(S),Length(S)+1);
     Sleep(500);
     S    := 'ATH'+#13;
     MainForm.Comm.WriteCommData(Pchar(S),Length(S)+1);
     //
     Close;
end;

procedure TForm_TelIn.Timer_AutoCloseTimer(Sender: TObject);
begin
     if GetTickCount-iLastRing>10000 then begin
          Close;
     end;
end;

end.
