unit Unit1;

interface

uses
  wxoExec,
  XPMan,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    Edit_URL: TEdit;
    Button_SetTitle: TButton;
    Edit_Title: TEdit;
    Button_Reload: TButton;
    Button_Close: TButton;
    Button_wxoMessageDlg: TButton;
    Label2: TLabel;
    Button2: TButton;
    Edit_Dir: TEdit;
    Button3: TButton;
    Memo1: TMemo;
    Button4: TButton;
    Button5: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button_SetTitleClick(Sender: TObject);
    procedure Button_ReloadClick(Sender: TObject);
    procedure Button_CloseClick(Sender: TObject);
    procedure Button_wxoMessageDlgClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  wxoPrepare(Handle,Application.Handle);
  wxoAddMonitor(Form1);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Edit_URL.Text  := _wxoGetUrl;
end;

procedure TForm1.Button_SetTitleClick(Sender: TObject);
begin
  wxoSetTitle(PAnsiChar(Edit_Title.Text));
end;

procedure TForm1.Button_ReloadClick(Sender: TObject);
begin
  wxoReload;
end;

procedure TForm1.Button_CloseClick(Sender: TObject);
begin
  wxoClose;
end;

procedure TForm1.Button_wxoMessageDlgClick(Sender: TObject);
begin
  if wxoMessageDlg(Self,'Are you sure to save?',mtConfirmation,[mbOK,mbCancel],0)=mrOK then
  begin
    Label2.Caption := 'OK!!!!!  :)';
  end
  else
  begin
    Label2.Caption := 'Cancel   :(' ;
  end;
          
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Edit_Dir.Text  := _wxoGetDir;    

end;

procedure TForm1.Button3Click(Sender: TObject);
begin
     wxoRunJS(PAnsiChar(Memo1.Text));
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
     wxoShowModal(Form2,Form1);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
     wxoShow(Form2,Form1);

end;

end.
 