unit BackupConfig;

interface

uses
     SysConsts,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,MsgDlg,
  Dialogs, StdCtrls, ExtCtrls, FileCtrl, RzFilSys, Mask, RzEdit, RzSpnEdt;

type
  TForm_BackupConfig = class(TForm)
    DriveComboBox: TRzDriveComboBox;
    Panel1: TPanel;
    Panel2: TPanel;
    Button_OK: TButton;
    Button_Cancel: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    SpinEdit: TRzSpinEdit;
    Image: TImage;
    Bevel1: TBevel;
    procedure Button_CancelClick(Sender: TObject);
    procedure Button_OKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form_BackupConfig: TForm_BackupConfig;

implementation

uses Main;

{$R *.dfm}


procedure TForm_BackupConfig.Button_CancelClick(Sender: TObject);
begin
     Close;
end;

procedure TForm_BackupConfig.Button_OKClick(Sender: TObject);
var
     sBak : String;
begin
     sBak := DriveComboBox.Drive+':\CutePIMBaks';
     if not DirectoryExists(sBak) then begin
          ChDir(DriveComboBox.Drive+':\');
          MkDir(sBak);
     end;
     //
     if DirectoryExists(sBak) then begin
          MainForm.SetSystemByID(sBak,siBackupDir);
          MainForm.SetSystemByID(IntToStr(SpinEdit.IntValue),siBackupDays);
          Close;
     end else begin
          MessageDialogWithFont(#13+'δɹ,ѡһλ!'+#13,mtInformation,[mbOK],Font,Font);
     end;
end;

procedure TForm_BackupConfig.FormShow(Sender: TObject);
var
     sTmp : String;
begin
     //ʾλ
     Left := (Screen.Width-Width) div 2;
     Top  := Round((Screen.Height*0.67-Height)/2);

     //
     sTmp := MainForm.GetSystemByID(siBackupDir);
     if Length(sTmp)>0 then begin
          DriveComboBox.Drive := sTmp[1];
     end;

     //
     sTmp := MainForm.GetSystemByID(siBackupDays);
     SpinEdit.IntValue   := StrToIntDef(sTmp,3);


end;

end.
