unit ChangeGroup;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls,MsgDlg;

type
  TForm_ChangeGroup = class(TForm)
    RadioGroup: TRadioGroup;
    TreeView: TTreeView;
    Panel1: TPanel;
    Panel2: TPanel;
    Button_OK: TButton;
    Button_Cancel: TButton;
    ComboBox: TComboBox;
    procedure Button_CancelClick(Sender: TObject);
    procedure Button_OKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
     Form_ChangeGroup: TForm_ChangeGroup;

implementation

uses Main,MyDatas;

{$R *.dfm}


procedure TForm_ChangeGroup.Button_CancelClick(Sender: TObject);
begin
     Close;
end;

procedure TForm_ChangeGroup.Button_OKClick(Sender: TObject);
var
     sSrcGID   : string;      //ԴID
     sDestGID  : String;     //ĿID
     sGName    : string;
     iPos      : Integer;
     sSQL      : string;
begin
     sGName    := ComboBox.Text;
     iPos      := Pos(']:',sGName);
     sSrcGID   := Copy(sGName,2,iPos-2);
     Case RadioGroup.ItemIndex of
          0 : begin //
               if ComboBox.Items.Count=0 then begin
                    MessageDialog(#13+#13+'ǰԱκһ,,ѡ""!'+#13+#13,mtConfirmation, [mbOK], 0);
               end else begin
                    sDestGID  := IntToStr(Integer(MainForm.TreeView.Items[TreeView.Selected.AbsoluteIndex].Data));
                    sSQL      := 'UPDATE PersonLink SET GroupID='+sDestGID+' WHERE PersonID='+IntToStr(iPersonID)+' AND GroupID='+sSrcGID;
                    DM.ADOConnection.Execute(sSQL);
               end;
          end;
          1 : begin //
               sDestGID  := IntToStr(Integer(MainForm.TreeView.Items[TreeView.Selected.AbsoluteIndex].Data));

               sSQL      := 'INSERT INTO PersonLink(GroupID,PersonID) VALUES('+sDestGID+','+IntToStr(iPersonID)+')';
               DM.ADOConnection.Execute(sSQL);
          end;
          2 : begin //ɾ
               //
               if ComboBox.Items.Count=0 then begin
                    MessageDialog(#13+#13+'ǰԱκһ,ɾδɹ!'+#13+#13,mtConfirmation, [mbOK], 0);
               end else begin
                    DM.ADOConnection.Execute('DELETE FROM PersonLink WHERE PersonID='+IntToStr(iPersonID)+' AND GroupID='+sSrcGID);
               end;
               //
          end;
     end;
     Close;
end;

procedure TForm_ChangeGroup.FormShow(Sender: TObject);
begin
     RadioGroup.ItemIndex     := 0;
end;

end.
