unit ChangeIcon;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, ImgList;

type
  TForm_ChangeIcon = class(TForm)
    ListView: TListView;
    Panel1: TPanel;
    Panel2: TPanel;
    Button_OK: TButton;
    Button_Cancel: TButton;
    procedure FormShow(Sender: TObject);
    procedure Button_CancelClick(Sender: TObject);
    procedure Button_OKClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form_ChangeIcon: TForm_ChangeIcon;


implementation

uses Main;

{$R *.dfm}

procedure TForm_ChangeIcon.FormShow(Sender: TObject);
var
     I    : Integer;
begin
     ListView.Items.Clear;
     for I:=3 to MainForm.ImageList_Small.Count-1 do begin
          with ListView.Items.Add do begin
               Caption := IntToStr(I-2);
               ImageIndex     := I-3;
          end;
     end;
end;

procedure TForm_ChangeIcon.Button_CancelClick(Sender: TObject);
begin
     Tag  := 0;
     Close;
end;

procedure TForm_ChangeIcon.Button_OKClick(Sender: TObject);
begin
     Tag  := ListView.Items[ListView.ItemIndex].ImageIndex;
     Close;
end;

end.
