unit DataEdit;

interface

uses
     SysVars,SysConsts,SysRecords,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Grids, DBGrids, MyDbGrid,DB,
  DBCtrls, Mask, DBNavPlus;

type
  TForm_Edit = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Button_OK: TButton;
    Button_Cancel: TButton;
    PageControl_Mode: TPageControl;
    TabSheet_Detail: TTabSheet;
    TabSheet_Batch: TTabSheet;
    DBEdit1: TDBEdit;
    DBComboBox1: TDBComboBox;
    DBNavigator: TDBNavigator;
    Panel3: TPanel;
    DBGrid: TMyDBGrid;
    procedure Button_CancelClick(Sender: TObject);
    procedure Button_OKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
     Form_Edit: TForm_Edit;

implementation

uses Main;

{$R *.dfm}

procedure TForm_Edit.Button_CancelClick(Sender: TObject);
begin
     //ȡ޸
     if MainForm.RemoteADOQuery.State in [dsEdit,dsInsert] then begin
          MainForm.RemoteADOQuery.Cancel;
     end;
     //˳
     Close;
end;

procedure TForm_Edit.Button_OKClick(Sender: TObject);
var
     I    : Integer;
begin
     //޸
     if MainForm.RemoteADOQuery.State in [dsEdit,dsInsert] then begin
          MainForm.RemoteADOQuery.Post;
     end;
     MainForm.RemoteADOQuery.Append;
     Tag  := 0;
     //˳
     Close;
//     //ҵһؼ,Ϊ
//     if PageControl_Mode.ActivePageIndex=0 then begin
//          for I:=0 to TabSheet_Detail.ControlCount-1 do begin
//               if TabSheet_Detail.Controls[I].ClassType = TDBEdit then begin
//                    TDBEdit(TabSheet_Detail.Controls[I]).SetFocus;
//                    break;
//               end else if TabSheet_Detail.Controls[I].ClassType = TDBComboBox then begin
//                    TDBComboBox(TabSheet_Detail.Controls[I]).SetFocus;
//                    break;
//               end;
//          end;
//     end;
     //


end;

procedure TForm_Edit.FormShow(Sender: TObject);
var
     I,J,iTop  : Integer;
     iLeft     : Integer;
     oLabel    : TLabel;
     oEdit     : TDBEdit;
     oCombo    : TDBComboBox;
     iCount    : Integer;
     sGrid     : String;
begin
     Tag  := 0;     //ڿϵʱ"ȡ"ʱɾ
     //----------------------ϸ༭Ŀؼ---------------------------------------------------//
     //µĿؼ
     for I:=TabSheet_Detail.ControlCount-1 downto 0 do begin
          TabSheet_Detail.Controls[0].Destroy;
     end;

     //ʾֶбֶδ,ڿжǷʾ
     sGrid     := ',';
     for I:=0 to High(grGrid_Member) do begin
          sGrid     := sGrid+IntToStr(grGrid_Member[I])+',';
     end;

     //Ĭֶֻ()
     iCount    := 0;
     for I:=0 to High(grFields_Member) do begin
          if Pos(','+IntToStr(I)+',',sGrid)>0 then begin
               //λ
               iTop      := 20+(iCount div 2)*30;
               iLeft     := 10+(iCount mod 2)*280;
               //ɱǩ
               oLabel         := TLabel.Create(self);
               oLabel.Parent  := TabSheet_Detail;
               oLabel.Left    := iLeft;
               oLabel.Top     := iTop+3;
               oLabel.Caption := grFields_Member[I].Caption;

               //ɱ༭/Ͽ
               if grFields_Member[I].SelList.Count>0 then begin
                    oCombo         := TDBComboBox.Create(self);
                    oCombo.Parent  := TabSheet_Detail;
                    oCombo.Left    := iLeft+85;
                    oCombo.Top     := iTop;
                    oCombo.Width   := 155;
                    oCombo.AutoComplete := False;
                    oCombo.DataSource   := MainForm.DataSource;
                    oCombo.DataField    := 'Item'+IntToStr(I);
                    oCombo.Items        := grFields_Member[I].SelList;
               end else begin
                    oEdit          := TDBEdit.Create(self);
                    oEdit.Parent   := TabSheet_Detail;
                    oEdit.Left     := iLeft+85;
                    oEdit.Top      := iTop;
                    oEdit.Width    := 155;
                    oEdit.DataSource    := MainForm.DataSource;
                    oEdit.DataField     := 'Item'+IntToStr(I);
               end;

               //
               Inc(iCount);
          end;
     end;


     //----------------------༭Ŀؼ---------------------------------------------------//
     DBGrid.Columns.Clear;
     //ֶ
     for I:=0 to High(grFields_Member) do begin
          if Pos(','+IntToStr(I)+',',sGrid)>0 then begin
               with DBGrid.Columns.Add do begin
                    FieldName      := 'Item'+IntToStr(I);
                    Width          := grFields_Member[I].ViewWidth;
                    Title.Caption  := grFields_Member[I].Caption;
                    PickList       := grFields_Member[I].SelList;
               end;
          end;
     end;
     //ɷֶ
     for I:=0 to High(grFields_Member) do begin
          if Pos(','+IntToStr(I)+',',sGrid)<=0 then begin
               with DBGrid.Columns.Add do begin
                    FieldName      := 'Item'+IntToStr(I);
                    Width          := grFields_Member[I].ViewWidth;
                    Title.Caption  := grFields_Member[I].Caption;
                    PickList       := grFields_Member[I].SelList;
               end;
          end;
     end;


     //
     PageControl_Mode.ActivePageIndex   := 0;

end;

procedure TForm_Edit.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if Key=13 then begin
          PostMessage(HANDLE,WM_KEYDOWN,vk_TAB,0);
     end; 
end;


end.
