unit DataHouse;

interface

uses
     //
     SysConsts,SysVars,
     //
  SysUtils, Windows, Messages, Classes, Graphics, Controls, Forms,
  Dialogs, DBTables, DB, ADODB,MyFuncs,IMCode,MsgDlg,ShellAPI,Grids,
  RemoteAdoUnit;

type
  TDM = class(TDataModule)
    RemoteAdoConnection: TRemoteAdoConnection;
    RemoteAdoQuery_Password: TRemoteAdoQuery;
    RemoteAdoQuery_Exec: TRemoteAdoQuery;
    DataSource: TDataSource;
    RemoteAdoQuery: TRemoteAdoQuery;
    DataSource_Resume: TDataSource;
    RemoteAdoQuery_Resume: TRemoteAdoQuery;
    DataSource_Family: TDataSource;
    RemoteAdoQuery_Family: TRemoteAdoQuery;
    procedure DataModuleCreate(Sender: TObject);
    procedure ADOQueryAfterInsert(DataSet: TDataSet);
    procedure ADOQuery_ResumeAfterInsert(DataSet: TDataSet);
    procedure ADOQuery_FamilyAfterInsert(DataSet: TDataSet);
    procedure ADOQueryBeforeDelete(DataSet: TDataSet);
    procedure ADOQueryBeforePost(DataSet: TDataSet);
    procedure ADOQueryAfterPost(DataSet: TDataSet);
  private
    { Private declarations }
  public
     procedure ExeAQ(AQ:TRemoteADOQuery;S:String);
       procedure ExecuteSQL(SQL:String);
  end;

var
     DM   : TDM;                  
implementation

uses Main, DataEdit,BackupConfig;

{$R *.dfm}

procedure TDM.DataModuleCreate(Sender: TObject);
begin
     //ȡõǰ·
     //gsMainDir   := ExtractFilePath(Application.ExeName);
     gsMainDir   := GetCurrentDir+'\';
     //
     SetLength(grFields_Member,giMemberFieldCount-1);
     SetLength(grFields_Resume,6);
     SetLength(grFields_Family,6);
end;

procedure TDM.ADOQueryAfterInsert(DataSet: TDataSet);
begin
     if MainForm.TreeView.Selected=nil then begin
          RemoteADOQuery.Cancel;
     end else begin
          if RemoteADOQuery.State in [dsEdit,dsInsert] then begin
               RemoteADOQuery.FieldByName('GroupIDs').AsString := ','
                         +IntToStr(MainForm.TreeView.Selected.StateIndex)+',';
               RemoteADOQuery.Post;
               RemoteADOQuery.Edit;
          end;
     end;
end;

procedure TDM.ADOQuery_ResumeAfterInsert(DataSet: TDataSet);
begin
     RemoteADOQuery_Resume.FieldByName('LinkID').AsInteger := giMoveID;
     RemoteADOQuery_Resume.Post;
     RemoteADOQuery_Resume.Edit;
end;

procedure TDM.ADOQuery_FamilyAfterInsert(DataSet: TDataSet);
begin
     RemoteADOQuery_Family.FieldByName('LinkID').AsInteger := giMoveID;
     RemoteADOQuery_Family.Post;
     RemoteADOQuery_Family.Edit;
end;

procedure TDM.ADOQueryBeforeDelete(DataSet: TDataSet);
var
     TmpS : string;
begin
     try
          //ɾеǰԱļϵ
          TmpS := 'Delete From Resume Where LinkID ='+IntToStr(giMoveID);
          MainForm.ADOCommand.CommandText   := TmpS;
          MainForm.ADOCommand.Execute;
          TmpS := 'Delete From Family Where LinkID ='+IntToStr(giMoveID);
          MainForm.ADOCommand.CommandText   := TmpS;
          MainForm.ADOCommand.Execute;
     except
     end;
end;

procedure TDM.ADOQueryBeforePost(DataSet: TDataSet);
begin
     DM.RemoteADOQuery.FieldByName('Spell').AsString   := MakeSpellCode(DM.RemoteADOQuery.FieldByName('Item0').AsString,2,255);
     DM.RemoteADOQuery.AfterScroll(DM.RemoteADOQuery);
end;

procedure TDM.ExeAQ(AQ: TRemoteADOQuery; S: String);
begin
     //
     try
          AQ.Close;
          AQ.SQL.Text    := S;
          if Copy(Lowercase(S),1,7)='select ' then begin
               AQ.Open;
          end else begin
               AQ.ExecSQL;
          end;
     except
          ShowMessage(S);
     end;

end;

procedure TDM.ADOQueryAfterPost(DataSet: TDataSet);
begin
     Form_Edit.Tag  := 1;     //ݱ༭ʱǷˢ
end;

procedure TDM.ExecuteSQL(SQL: String);
begin
     RemoteAdoQuery_Exec.Close;
     RemoteAdoQuery_Exec.SQL.Text  := SQL;
     RemoteAdoQuery_Exec.ExecSQL;
end;

end.
