unit FieldEdit;

interface

uses
     SysVars,SysConsts,SysRecords,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, Mask, RzEdit, RzSpnEdt, Grids,DB,
  DBCtrls, ImgList, ADODB, RemoteAdoUnit;

type
  TForm_FieldEdit = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Button_Prev: TButton;
    Button_Cancel: TButton;
    PageControl: TPageControl;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    Button_Next: TButton;
    RadioGroup_Table: TRadioGroup;
    Label1: TLabel;
    Edit_Name: TEdit;
    Label2: TLabel;
    SpinEdit_Width: TRzSpinEdit;
    Label3: TLabel;
    Memo: TMemo;
    Label4: TLabel;
    StringGrid_Demo: TStringGrid;
    ListView: TListView;
    ImageList: TImageList;
    Panel_Info: TPanel;
    Label_Mode: TLabel;
    ComboBox_Mode: TComboBox;
    RemoteAdoQuery: TRemoteAdoQuery;
    procedure FormShow(Sender: TObject);
    procedure Button_PrevClick(Sender: TObject);
    procedure Button_NextClick(Sender: TObject);
    procedure Button_CancelClick(Sender: TObject);
    procedure StringGrid_DemoMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Edit_NameChange(Sender: TObject);
    procedure SpinEdit_WidthChange(Sender: TObject);
    procedure MemoChange(Sender: TObject);
    procedure ListViewChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
     Form_FieldEdit: TForm_FieldEdit;

implementation

uses  Main;

{$R *.dfm}

procedure TForm_FieldEdit.FormShow(Sender: TObject);
begin
     //ҳ
     PageControl.Pages[0].TabVisible    := True;
     PageControl.Pages[1].TabVisible    := False;
     PageControl.Pages[2].TabVisible    := False;
     //ťԭʼ״̬
     Button_Prev.Enabled := False;
     Button_Next.Enabled := True;
     Button_Next.Caption := 'һ(&X)';
     //
     RemoteADOQuery.Connection := MainForm.RemoteAdoConnection;
end;

procedure TForm_FieldEdit.Button_PrevClick(Sender: TObject);
begin
     case PageControl.ActivePageIndex of
          1 : begin
               //ҳ
               PageControl.Pages[0].TabVisible    := True;
               PageControl.Pages[1].TabVisible    := False;
               PageControl.Pages[2].TabVisible    := False;
               //ťԭʼ״̬
               Button_Prev.Enabled := False;
               Button_Next.Caption := 'һ(&X)';
          end;
          2 : begin
               //ҳ
               PageControl.Pages[0].TabVisible    := False;
               PageControl.Pages[1].TabVisible    := True;
               PageControl.Pages[2].TabVisible    := False;
               //ťԭʼ״̬
               Button_Prev.Enabled := True;
               Button_Next.Caption := 'һ(&X)';
          end;
     end;
end;

procedure TForm_FieldEdit.Button_NextClick(Sender: TObject);
var
     I,J,iID   : Integer;
begin
     //ʾ/ֶѡ
     //Label_Mode.Visible       := RadioGroup_Table.ItemIndex=0;
     //ComboBox_Mode.Visible    := Label_Mode.Visible;

     //ʾǰԵϢ
     iID  := ListView.ItemIndex;
     case PageControl.ActivePageIndex of
          //---һҳ
          0 : begin
               //ҳ
               PageControl.Pages[0].TabVisible    := False;
               PageControl.Pages[1].TabVisible    := True;
               PageControl.Pages[2].TabVisible    := False;
               //ťԭʼ״̬
               Button_Prev.Enabled := True;
               Button_Next.Caption := 'һ(&X)';
               //ֶ̬
               ListView.Items.Clear;
               case RadioGroup_Table.ItemIndex of
                    0 : begin
                         for I:=0 to High(grFields_Member) do begin
                              ListView.Items.Add.Caption    := (grFields_Member[I].Caption);
                         end;
                    end;
                    1 : begin
                         for I:=0 to High(grFields_Family) do begin
                              ListView.Items.Add.Caption    := (grFields_Family[I].Caption);
                         end;
                    end;
                    2 : begin
                         for I:=0 to High(grFields_Resume) do begin
                              ListView.Items.Add.Caption    := (grFields_Resume[I].Caption);
                         end;
                    end;
               end;
               //ListView.Height  := RadioGroup_Field.Items.Count*18;
               //
               ListView.ItemIndex    := 0;
               ListView.Items[0].Selected    := True;
          end;

          //ڶҳ
          1 : begin
               //ҳ
               PageControl.Pages[0].TabVisible    := False;
               PageControl.Pages[1].TabVisible    := False;
               PageControl.Pages[2].TabVisible    := True;

               //ťԭʼ״̬
               Button_Prev.Enabled := True;
               Button_Next.Caption := '(&S)';
               case RadioGroup_Table.ItemIndex of
                    0 : begin
                         //ʾֶѡ
                         //Label_Mode.Visible       := True;
                         //ComboBox_Mode.Visible    := True;
                         //ɸ
                         ComboBox_Mode.ItemIndex  := grFields_Member[iID].Mode;      //
                         Edit_Name.Text           := grFields_Member[iID].Caption;   //
                         SpinEdit_Width.IntValue  := grFields_Member[iID].ViewWidth; //ʾ
                         Memo.Text                := grFields_Member[iID].SelList.Text;   //ѡ
                    end;
                    1 : begin
                         Edit_Name.Text := grFields_Family[iID].Caption;
                         SpinEdit_Width.IntValue  := grFields_Family[iID].ViewWidth;
                         Memo.Text := grFields_Family[iID].SelList.Text;
                    end;
                    2 : begin
                         Edit_Name.Text := grFields_Resume[iID].Caption;
                         SpinEdit_Width.IntValue  := grFields_Resume[iID].ViewWidth;
                         Memo.Text := grFields_Resume[iID].SelList.Text;
                    end;
               end;
               //
               StringGrid_Demo.ColWidths[0]  := SpinEdit_Width.IntValue;
               StringGrid_Demo.Cells[0,0]    := Edit_Name.Text;
               for I:=1 to StringGrid_Demo.RowCount-1 do begin
                    StringGrid_Demo.Cells[0,I]    := '';
               end;
               for I:=0 to Memo.Lines.Count-1 do begin
                    StringGrid_Demo.Cells[0,I+1]  := Memo.Lines[I];
               end;

          end;

          //ҳ
          2 : begin
               //. Ҫ4
               //1. 浽ݿ
               //2. 
               //3. ¸ҳ(ϵͼ)
               //4. ˵
               //5. 浽ڴ

               //ݿǷTableID=0ItemID=30,...,99,û(Ҫӵ100ֶ)
               for I:=30 to 100 do begin
                    MainForm.ExeAQ(RemoteADOQuery,'SELECT * FROM FieldConfig WHERE TableID=0 AND ItemID='+IntToStr(I));
                    if RemoteADOQuery.IsEmpty then begin
                         //DM.ExeAQ(RemoteADOQuery,'INSERT INTO FieldConfig (TableID,ItemID) VALUES(0,'+IntToStr(I)+')');
                         RemoteADOQuery.Append;
                         RemoteADOQuery.FieldByName('TableID').AsInteger    := 0;
                         RemoteADOQuery.FieldByName('ItemID').AsInteger     := I;
                         RemoteADOQuery.FieldByName('ItemName').AsString    := 'δʹ';
                         RemoteADOQuery.Post;
                    end else begin
                         break;
                    end;
               end;

               //浽ݿ
               MainForm.ExecuteSQL('UPDATE FieldConfig '
                         +' SET ItemName='''+Edit_Name.Text+''','
                         +' Width='+IntToStr(SpinEdit_Width.IntValue)+','
                         +' Mode='+IntToStr(ComboBox_Mode.ItemIndex)+','
                         +' PickList='''+Memo.Text+''''
                         +' WHERE TableID='+IntToStr(RadioGroup_Table.ItemIndex)+' AND ItemID='+IntToStr(iID));

               //-------------ǳԱ,Ҫ2,3,4,5------------------------------------//
               if RadioGroup_Table.ItemIndex=0 then begin
                    //2. 
                    for I:=0 to MainForm.DBGrid.Columns.Count-1 do begin
                         if MainForm.DBGrid.Columns[I].FieldName = Format('Item%d',[iID]) then begin
                              MainForm.DBGrid.Columns[I].Title.Caption     := Edit_Name.Text;
                              MainForm.DBGrid.Columns[I].Width             := SpinEdit_Width.IntValue;
                              Break;
                         end;
                    end;
                      //3. ¸ҳ(ݲDBEdit/DBComboBox)
                    for I:=0 to 3 do begin
                         for J:=0 to MainForm.PageControl_Detail.Pages[I].ControlCount-1 do begin
                              //DBComboBox
                              if MainForm.PageControl_Detail.Pages[I].Controls[J].ClassType = TDBComboBox then begin
                                   TDBComboBox(MainForm.PageControl_Detail.Pages[I].Controls[J]).Items.Text   := Memo.Text;
                                   break;
                              end;
                              //±ǩ
                              if MainForm.PageControl_Detail.Pages[I].Controls[J].ClassType = TLabel then begin
                                   if TLabel(MainForm.PageControl_Detail.Pages[I].Controls[J]).Tag = iID then begin
                                        TLabel(MainForm.PageControl_Detail.Pages[I].Controls[J]).Caption := Edit_Name.Text;
                                   end;
                                   break;
                              end;
                         end;
                    end;

                    //4. ˵
                    for I:=0 to MainForm.TBXSubmenuItem_Sort.Count-1 do begin
                         if MainForm.TBXSubmenuItem_Sort.Items[I].Tag = iID then begin
                              MainForm.TBXSubmenuItem_Sort.Items[I].Caption := Edit_Name.Text;
                              MainForm.PopMenu_Sort.Items[I].Caption  := Edit_Name.Text;
                              Break;
                         end;
                    end;

                    //5. 浽ڴ
                    grFields_Member[iID].Caption         := Edit_Name.Text;
                    grFields_Member[iID].ViewWidth       := SpinEdit_Width.IntValue;
                    grFields_Member[iID].SelList.Text    := Memo.Text;
               end;


               //-------------ϵ,Ҫ3,5------------------------------------//
               if RadioGroup_Table.ItemIndex=1 then begin
                    //3. ¸ҳ(ϵ)
                    for I:=0 to MainForm.DBGrid_Family.Columns.Count-1 do begin
                         if UpperCase(MainForm.DBGrid_Family.Columns[I].FieldName)='ITEM'+IntToStr(iID) then begin
                              MainForm.DBGrid_Family.Columns[I].Title.Caption   := Edit_Name.Text;
                              MainForm.DBGrid_Family.Columns[I].Width           := SpinEdit_Width.IntValue;
                              MainForm.DBGrid_Family.Columns[I].PickList.Text   := Memo.Text;
                              break;
                         end;
                    end;

                    //5.浽ڴ
                    grFields_Family[iID].Caption         := Edit_Name.Text;
                    grFields_Family[iID].ViewWidth       := SpinEdit_Width.IntValue;
                    grFields_Family[iID].SelList.Text    := Memo.Text;
               end;

               //-------------Ǽ,Ҫ3,5----------------------------------------//
               if RadioGroup_Table.ItemIndex=2 then begin
                    //3. ¸ҳ()
                    for I:=0 to MainForm.DBGrid_Resume.Columns.Count-1 do begin
                         if UpperCase(MainForm.DBGrid_Resume.Columns[I].FieldName)='ITEM'+IntToStr(iID) then begin
                              MainForm.DBGrid_Resume.Columns[I].Title.Caption   := Edit_Name.Text;
                              MainForm.DBGrid_Resume.Columns[I].Width           := SpinEdit_Width.IntValue;
                              MainForm.DBGrid_Resume.Columns[I].PickList.Text   := Memo.Text;
                              break;
                         end;
                    end;

                    //5.浽ڴ
                    grFields_Resume[iID].Caption         := Edit_Name.Text;
                    grFields_Resume[iID].ViewWidth       := SpinEdit_Width.IntValue;
                    grFields_Resume[iID].SelList.Text    := Memo.Text;
               end;
          end;
     end;

end;

procedure TForm_FieldEdit.Button_CancelClick(Sender: TObject);
begin
     Close;
end;

procedure TForm_FieldEdit.StringGrid_DemoMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     SpinEdit_Width.IntValue  := StringGrid_Demo.ColWidths[0];

end;

procedure TForm_FieldEdit.Edit_NameChange(Sender: TObject);
begin
     StringGrid_Demo.Cells[0,0]    := Edit_Name.Text;

end;

procedure TForm_FieldEdit.SpinEdit_WidthChange(Sender: TObject);
begin
     StringGrid_Demo.ColWidths[0]  := SpinEdit_Width.IntValue ;

end;

procedure TForm_FieldEdit.MemoChange(Sender: TObject);
var
     I    : Integer;
begin
     for I:=1 to StringGrid_Demo.RowCount-1 do begin
          StringGrid_Demo.Cells[0,I]    := '';
     end;
     for I:=0 to Memo.Lines.Count-1 do begin
          StringGrid_Demo.Cells[0,I+1]  := Memo.Lines[I];
     end;

end;

procedure TForm_FieldEdit.ListViewChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
var
     iID  : Integer;
     sTmp : String;
begin
     iID  := ListView.ItemIndex;
     if iID<0 then Exit;
     //
     case RadioGroup_Table.ItemIndex of
          0 : begin
               sTmp := ' ['+IntToStr(iID)+'] :'+IntToStr(grFields_Member[iID].ViewWidth)
                         +' = '+grFields_Member[iID].SelList.Text
          end;
          1 : begin
               sTmp := ' ['+IntToStr(iID)+'] :'+IntToStr(grFields_Family[iID].ViewWidth)
                         +' = '+grFields_Family[iID].SelList.Text
          end;
          2 : begin
               sTmp := ' ['+IntToStr(iID)+'] :'+IntToStr(grFields_Resume[iID].ViewWidth)
                         +' = '+grFields_Resume[iID].SelList.Text
          end;
     end;
     sTmp := ' '+StringReplace(sTmp,#13#10,',',[rfReplaceAll]);
     if sTmp[Length(sTmp)]=',' then begin
          Delete(sTmp,Length(sTmp),1);
     end;
     //
     Panel_Info.Caption  := sTmp;
end;

end.
