unit InputRegCode;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,MsgDlg,ShellAPI;

type
  TForm_InputRegCode = class(TForm)
    Label1: TLabel;
    Edit_RegName: TEdit;
    Label2: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    Button_OK: TButton;
    Button_Cancel: TButton;
    Memo_RegCode: TMemo;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Label3: TLabel;
    Bevel1: TBevel;
    procedure Button_CancelClick(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure Edit_RegNameChange(Sender: TObject);
    procedure Memo_RegCodeChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
     Form_InputRegCode: TForm_InputRegCode;

implementation

uses Main;

{$R *.dfm}

procedure TForm_InputRegCode.Button_CancelClick(Sender: TObject);
begin
     Close;
end;

procedure TForm_InputRegCode.RadioButton1Click(Sender: TObject);
begin
     RadioButton2.Checked     := not RadioButton1.Checked;
end;

procedure TForm_InputRegCode.RadioButton2Click(Sender: TObject);
begin
     RadioButton1.Checked     := not RadioButton2.Checked;
end;

procedure TForm_InputRegCode.Edit_RegNameChange(Sender: TObject);
begin
     RadioButton1.Checked     := True;
end;

procedure TForm_InputRegCode.Memo_RegCodeChange(Sender: TObject);
begin
     RadioButton1.Checked     := True;
end;

end.
