unit MemberFieldEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ComCtrls, XPButton,MyFuncs, StdCtrls, ExtCtrls;

type
  TForm_MemberFieldEdit = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel1: TPanel;
    Panel2: TPanel;
    Button_OK: TButton;
    Button_Cancel: TButton;
    StringGrid: TStringGrid;
    procedure FormShow(Sender: TObject);
    procedure Button_CancelClick(Sender: TObject);
    procedure Button_OKClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form_MemberFieldEdit: TForm_MemberFieldEdit;

implementation

{$R *.dfm}
uses Main;

procedure TForm_MemberFieldEdit.FormShow(Sender: TObject);
var
     I,J  : Integer;
     S    : String;
begin
     //
     StringGrid.Cells[0,0]    := ' ';
     StringGrid.Cells[1,0]    := ' ʾ';
     StringGrid.Cells[2,0]    := ' ѡ(öŸ)';
     StringGrid.RowCount      := Length(Fields_Member)+1;

     //

     for I:=0 to High(Fields_Member) do begin
          StringGrid.Cells[0,I+1]  := Fields_Member[I].Caption;
          StringGrid.Cells[1,I+1]  := IntToStr(Fields_Member[I].ViewWidth);
          S    := '';
          for J:=0 to Fields_Member[I].SelList.Count-1 do begin
               S    := S+Fields_Member[I].SelList[J]+',';
          end;
          if Fields_Member[I].SelList.Count>0 then begin
               Delete(S,Length(S),1);
          end;
          StringGrid.Cells[2,I+1]  := S;
     end;
end;

procedure TForm_MemberFieldEdit.Button_CancelClick(Sender: TObject);
begin
     Close;
end;

procedure TForm_MemberFieldEdit.Button_OKClick(Sender: TObject);
var
     I    : Integer;
     S    : String;
begin
     //浽Fields_Member
     for I:=0 to High(Fields_Member) do begin
          Fields_Member[I].Caption      := StringGrid.Cells[0,I+1];
          Fields_Member[I].ViewWidth    := StrToIntDef(StringGrid.Cells[1,I+1],80);
          Fields_Member[I].SelList      := StrToSelList(StringGrid.Cells[2,I+1]);
     end;
     //浽ļ
     MyFieldsToFile(Fields_Member,gsMainDir+'\Main.ini','Member');
     //ˢʾ
     //ˢµǰGRID
     with MainForm do begin
{aaa
          DBGrid.Columns.Clear;
          //
          for I:=0 to High(Grid_Member) do begin
               DBGrid.Columns.Add;
               with DBGrid.Columns[DBGrid.Columns.Count-1] do begin
                    FieldName  := 'Item'+IntToStr(Grid_Member[I]);
                    Width           := Fields_Member[Grid_Member[I]].ViewWidth;
                    Title.Caption   := Fields_Member[Grid_Member[I]].Caption;
                    PickList        := Fields_Member[Grid_Member[I]].SelList;
               end;
          end;
}
     end;
     Close;
end;

end.
