unit MyFuncs;

interface

uses
     SysRecords,
     Graphics,Windows,SysUtils,Classes,ComCtrls,DB,Types;

     
function GetID(Node : TTreeNode) : string;        //ȡĳڵID
function StrToSelList(S:string):TStringList;
function StrToMyField(S:string):TWWField;
function StrToIntArray(S:string):TIntegerDynArray;
//תƴĸĺ
function  HzToPy(Str:String):String;
//ַתɺƴĸĺ
function StrToPy(Str:String):String;
//canvasϻһPanel
procedure DrawPanel(canvas:TCanvas;Left,Top,Width,Height:integer;PanelType:integer);

function StrToPinYin( hzchar:string):String;

//ݿ¼һ,IDϢ¼StateIndex
procedure DataToTreeView(DataSet:TDataSet;sID,sLinkID,sName,sImageIndex:String;TV:TTreeView);

//ַָ
function  SplitStr(S,SplitStr:string):TStringDynArray;

implementation

const
     RaisedPanel = 1;
     LoweredPanel= 2;

function  SplitStr(S,SplitStr:string):TStringDynArray;
var
     P    : Integer;
begin
     SetLength(Result,0);
     while Pos(SplitStr,S)>0 do begin
          P    :=  Pos(SplitStr,S);
          SetLength(Result,Length(Result)+1);
          Result[High(Result)]     := Copy(S,1,P-1);
          Delete(S,1,P);
     end;
     if Length(S)>0 then begin
          SetLength(Result,Length(Result)+1);
          Result[High(Result)]     := S;
     end;
end;

procedure DataToTreeView(DataSet:TDataSet;sID,sLinkID,sName,sImageIndex:String;TV:TTreeView);
     procedure MyAdd(Node:TTreeNode);
     var
          I    : Integer;
     begin
          DataSet.Filter    := sLinkID+'='+IntToStr(Node.StateIndex);
          DataSet.Filtered  := True;

          while not DataSet.Eof do begin
               with TV.Items.AddChild(Node,DataSet.FieldByName(sName).AsString) do begin
                    //
                    if sImageIndex<>'' then begin
                         ImageIndex     := DataSet.FieldByName(sImageIndex).AsInteger;
                    end ;
                    SelectedIndex  := ImageIndex;
                    StateIndex     := DataSet.FieldByName(sID).AsInteger;
               end;
               //
               DataSet.Next;
          end;
          //
          for I:=0 to Node.Count-1 do begin
               MyAdd(Node.Item[I]);
          end;
     end;
begin
     //
     TV.Items.BeginUpdate;
     TV.Items[0].DeleteChildren;
     TV.Items[0].StateIndex   := 0;
     MyAdd(TV.Items[0]);
     TV.Items.EndUpdate;
     DataSet.Filtered    := False;
end;

function StrToPinYin( hzchar:string):String;
var
     I    : Integer;
begin
     Result    := '';
     for I:= 1 to Length(HzChar) div 2 do begin

          case WORD(hzchar[I*2-1]) shl 8 + WORD(hzchar[I*2]) of
               $B0A1..$B0C4 : result := result + 'A';
               $B0C5..$B2C0 : result := result + 'B';
               $B2C1..$B4ED : result := result + 'C';
               $B4EE..$B6E9 : result := result + 'D';
               $B6EA..$B7A1 : result := result + 'E';
               $B7A2..$B8C0 : result := result + 'F';
               $B8C1..$B9FD : result := result + 'G';
               $B9FE..$BBF6 : result := result + 'H';
               $BBF7..$BFA5 : result := result + 'J';
               $BFA6..$C0AB : result := result + 'K';
               $C0AC..$C2E7 : result := result + 'L';
               $C2E8..$C4C2 : result := result + 'M';
               $C4C3..$C5B5 : result := result + 'N';
               $C5B6..$C5BD : result := result + 'O';
               $C5BE..$C6D9 : result := result + 'P';
               $C6DA..$C8BA : result := result + 'Q';
               $C8BB..$C8F5 : result := result + 'R';
               $C8F6..$CBF9 : result := result + 'S';
               $CBFA..$CDD9 : result := result + 'T';
               $CDDA..$CEF3 : result := result + 'W';
               $CEF4..$D1B8 : result := result + 'X';
               $D1B9..$D4D0 : result := result + 'Y';
               $D4D1..$D7F9 : result := result + 'Z';
          else
               result := result + char(0);
          end;
     end;

end;





function GetID(Node : TTreeNode) : string;    //ȡĳڵID
var
     I         : Integer;
     TmpNode   : TTreeNode;
begin
     TmpNode   := Node;
     if TmpNode.Index <10 then begin
          Result    := '0'+IntToStr(TmpNode.Index);
     end else begin
          Result    := IntToStr(TmpNode.Index);
     end;
     for I := Node.Level downto 1 do begin
          TmpNode   := TmpNode.Parent;
          if TmpNode.Index <10 then begin
               Result    := '0'+IntToStr(TmpNode.Index)+Result;
          end else begin
               Result    := IntToStr(TmpNode.Index)+Result;
          end;
     end;
end;
function StrToIntArray(S:string):TIntegerDynArray;
var
     I    : Integer;
begin
     SetLength(Result,0);
     while Pos(',',S)>0 do begin
          I    := StrToInt(Copy(S,1,Pos(',',S)-1));
          SetLength(Result,Length(Result)+1);
          Result[High(Result)]     := I; 
          Delete(S,1,Pos(',',S));
     end;
     if Trim(S)<>'' then begin
          I    := StrToInt(S);
          SetLength(Result,Length(Result)+1);
          Result[High(Result)]     := I; 
     end;

end;
function StrToMyField(S:string):TWWField;
var  P    : Integer;
begin
     try
          //
          P    := Pos(';',S);
          Result.Caption := Copy(S,1,P-1);
          Delete(S,1,P);
          //
          P    := Pos(';',S);
          Result.ViewWidth := StrToInt(Copy(S,1,P-1));
          Delete(S,1,P);
          //ѡб
          Result.SelList := StrToSelList(S);
     except
     end;
end;
//','ֿбַ
function StrToSelList(S:string):TStringList;
var
     I    : Integer;
begin
     Result    := TStringList.Create;
     while Pos(',',S)>0 do begin
          Result.Add(Copy(S,1,Pos(',',S)-1));
          Delete(S,1,Pos(',',S));
     end;
     if Trim(S)<>'' then begin
          Result.Add(Trim(S));
     end;
end;

//ַתɺƴĸĺ
function StrToPy(Str:String):String;
var
     I    : Integer;
     TmpS : string;
begin
     Result    := '';
     for I:=0 to Length(Str) div 2 -1 do begin
          TmpS := Copy(Str,I*2+1,2);
          Result    := Result + HzToPy(TmpS);
     end;
end;
//תƴĸĺ
function  HzToPy(Str:String):String;
begin
     if ( Str>='' )and( Str<'') then  Result := 'a';
     if ( Str>='' )and( Str<'') then  Result := 'b';
     if ( Str>='' )and( Str<'') then  Result := 'c';
     if ( Str>='' )and( Str<'') then  Result := 'd';
     if ( Str>='' )and( Str<'') then  Result := 'e';
     if ( Str>='' )and( Str<'') then  Result := 'f';
     if ( Str>='' )and( Str<'') then  Result := 'g';
     if ( Str>='' )and( Str<'') then  Result := 'h';
     if ( Str>='' )and( Str<'') then  Result := 'j';
     if ( Str>='' )and( Str<'') then  Result := 'k';
     if ( Str>='' )and( Str<'') then  Result := 'l';
     if ( Str>='' )and( Str<'') then  Result := 'm';
     if ( Str>='' )and( Str<'Ŷ') then  Result := 'n';
     if ( Str>='Ŷ' )and( Str<'ž') then  Result := 'o';
     if ( Str>='ž' )and( Str<'') then  Result := 'p';
     if ( Str>='' )and( Str<'Ȼ') then  Result := 'q';
     if ( Str>='Ȼ' )and( Str<'') then  Result := 'r';
     if ( Str>='' )and( Str<'') then  Result := 's';
     if ( Str>='' )and( Str<'') then  Result := 't';
     if ( Str>='' )and( Str<'') then  Result := 'w';
     if ( Str>='' )and( Str<'ѹ') then  Result := 'x';
     if ( Str>='ѹ' )and( Str<'') then  Result := 'y';
     if ( Str>='')                then  Result := 'z';
     if ( Str>='a')and( Str<='z')   then  Result := Str;
     if ( Str>='A')and( Str<='Z')   then  Result := Str;
end;
//canvasϻһPanel
procedure DrawPanel(canvas:TCanvas;Left,Top,Width,Height:integer;PanelType:integer);
var
  Right,Bottom:integer;
  LeftTopColor,RightBottomColor:TColor;
begin
  //͹panel
  if PanelType=RaisedPanel  then
  begin
    LeftTopColor:=clwhite;
    RightBottomColor:=clgray;
  end
  else //ȥpanel
  begin

    LeftTopColor:=clgray;
    RightBottomColor:=clwhite;
  end;
      Right:=Left+width;
      Bottom:=Top+Height;

      Canvas.Pen.Width:=1;
      Canvas.Pen.Color:=LeftTopColor;

      Canvas.MoveTo(Right,Top);
      Canvas.lineTo(Left,Top);

      Canvas.LineTo(Left,bottom);

      Canvas.Pen.Color:=RightBottomColor;

      Canvas.lineTo(Right,Bottom);
      Canvas.lineTo(Right,Top);
end;

end.
