unit NewStat;

interface

uses
     SysVars,SysConsts,SysRecords,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Buttons, DB, ADODB,MsgDlg, Mask,
  RzEdit, RzSpnEdt, RemoteAdoUnit;

type
  TForm_NewStat = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Button_OK: TButton;
    Button_Cancel: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Label1: TLabel;
    Edit_Name: TEdit;
    ComboBox_Field: TComboBox;
    ComboBox_Compare: TComboBox;
    Edit_Value: TEdit;
    ListView: TListView;
    Button_Add: TSpeedButton;
    Button_Replace: TSpeedButton;
    Button_Del: TSpeedButton;
    Label2: TLabel;
    SpinEdit_Row: TRzSpinEdit;
    SpinEdit_Col: TRzSpinEdit;
    RemoteAdoQuery: TRemoteAdoQuery;
    procedure Button_CancelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button_OKClick(Sender: TObject);
    procedure Button_AddClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListViewChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure Button_ReplaceClick(Sender: TObject);
    procedure Button_DelClick(Sender: TObject);
    procedure ListViewClick(Sender: TObject);
  private
    { Private declarations }
  public
     StatName  : String; //ǰͳƵ
     ExprIndex : Integer;//ǰͳƵıʽ,Ϊ-1Ϊʽ
     ExprCaption    : String;
     Expression     : String;
     WritePosition  : String;
    { Public declarations }
  end;

var
     Form_NewStat   : TForm_NewStat;

implementation

{$R *.dfm}

uses Main;

procedure TForm_NewStat.Button_CancelClick(Sender: TObject);
begin
     Close;
end;

procedure TForm_NewStat.FormCreate(Sender: TObject);
var
     I    : Integer;
begin
     //ֶѡComboBox
     ComboBox_Field.Items.Clear;
     MainForm.ExeAQ(RemoteADOQuery,'SELECT * FROM FieldConfig WHERE TableID=0');
     //ļֶϢ
     for I:=0 to High(grFields_Member) do begin
          RemoteADOQuery.Locate('ItemID',I,[]);
          ComboBox_Field.Items.Add(RemoteADOQuery.FieldByName('ItemName').AsString);
     end;
     ComboBox_Field.ItemIndex :=0;

end;

procedure TForm_NewStat.Button_OKClick(Sender: TObject);
var
     I    : Integer;
begin
     //쳣
     if Trim(Edit_Name.Text)='' then begin
          MessageDialog(#13+'ƲΪ!'+#13,mtInformation,[mbOK],0);
          Exit;
     end;
     if ListView.Items.Count<=0 then begin
          MessageDialog(#13+'ıʽδЧо!'+#13,mtInformation,[mbOK],0);
          Exit;
     end;
     //Ϣ
     Tag  := 1;
     ExprCaption    := Edit_Name.Text;
     Expression     := '';
     for I:=0 to ListView.Items.Count-1 do begin
          Expression     := Expression+'('+ListView.Items[I].Caption+ListView.Items[I].SubItems[0]+ListView.Items[I].SubItems[1]+')';
          if I<ListView.Items.Count-1 then begin
               Expression     := Expression+'and';
          end;
     end;
     WritePosition  := '['+IntToStr(SpinEdit_Row.IntValue)+','+IntToStr(SpinEdit_Col.IntValue)+']';
     //
     Close;
end;

procedure TForm_NewStat.Button_AddClick(Sender: TObject);
var
     sVal      : String;
begin
     //쳣
     if Trim(Edit_Value.Text)='' then begin
          MessageDialog(#13+'ʽֵΪ!'+#13,mtInformation,[mbOK],0);
          Exit;
     end;

     //
     sVal := Edit_Value.Text;
     if ComboBox_Compare.Text='in' then begin
          if sVal[1]<>'(' then begin
               sVal := '['+sVal;
          end;
          if sVal[Length(sVal)]<>']' then begin
               sVal := sVal+']';
          end;
     end;

     //
     with ListView.Items.Add do begin
          Caption   := ComboBox_Field.Text;
          SubItems.Add(ComboBox_Compare.Text);
          SubItems.Add(sVal);
     end;
end;

procedure TForm_NewStat.FormShow(Sender: TObject);
begin
     Tag  := 0;
end;

procedure TForm_NewStat.ListViewChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
     //̬ť
     Button_Replace.Enabled   := ListView.Selected<>nil;
     Button_Del.Enabled       := Button_Replace.Enabled;

end;

procedure TForm_NewStat.Button_ReplaceClick(Sender: TObject);
var
     sVal : String;
begin
     if ListView.Selected=nil then Exit;

     //쳣
     if Trim(Edit_Value.Text)='' then begin
          MessageDialog(#13+'ʽֵΪ!'+#13,mtInformation,[mbOK],0);
          Exit;
     end;
     
     sVal := Edit_Value.Text;
     if ComboBox_Compare.Text='in' then begin
          if sVal[1]<>'(' then begin
               sVal := '['+sVal;
          end;
          if sVal[Length(sVal)]<>']' then begin
               sVal := sVal+']';
          end;
     end;
     //
     ListView.Selected.Caption     := ComboBox_Field.Text;
     ListView.Selected.SubItems[0] := ComboBox_Compare.Text;
     ListView.Selected.SubItems[1] := sVal;
end;

procedure TForm_NewStat.Button_DelClick(Sender: TObject);
begin
     if MessageDialog(#13+'ȷҪɾǰʽ?'#13+#13+'"'+ListView.Selected.Caption
               +ListView.Selected.SubItems[0]
               +ListView.Selected.SubItems[1]+'"'+#13,
               mtConfirmation, [mbYes, mbNo], 0) = mrYes then
     begin
          ListView.Selected.Delete;
     end;

end;

procedure TForm_NewStat.ListViewClick(Sender: TObject);
var
     I    : Integer;
begin
     //
     if ListView.Selected=nil then Exit;

     //̬лǰ
     for I:=0 to ComboBox_Field.Items.Count-1 do begin
          if ComboBox_Field.Items[I]=ListView.Selected.Caption then begin
               ComboBox_Field.ItemIndex := I;
               break;
          end;
     end;
     for I:=0 to ComboBox_Compare.Items.Count-1 do begin
          if ComboBox_Compare.Items[I]=ListView.Selected.SubItems[0] then begin
               ComboBox_Compare.ItemIndex := I;
               break;
          end;
     end;
     Edit_Value.Text          := ListView.Selected.SubItems[1];

end;

end.
